=== applications/CMakeLists.txt ===
add_custom_target(applications)

add_subdirectory(Coloring EXCLUDE_FROM_ALL)
add_subdirectory(CycleClustering EXCLUDE_FROM_ALL)
add_subdirectory(MinIISC EXCLUDE_FROM_ALL)
add_subdirectory(Ringpacking EXCLUDE_FROM_ALL)
add_subdirectory(PBSolver EXCLUDE_FROM_ALL)
add_subdirectory(Scheduler EXCLUDE_FROM_ALL)

enable_testing()
