=== src/CMakeLists.txt ===
#
# interface function for setting common library properties
#
include(GNUInstallDirs)

function(setLibProperties targetname outputname)
    set_target_properties(${targetname} PROPERTIES
        OUTPUT_NAME ${outputname})
endfunction(setLibProperties)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED on)
set(CMAKE_C_EXTENSIONS OFF)

if(NOT WIN32)
    set(SCIP_COMP_OPTIONS ${SCIP_COMP_OPTIONS} "$<$<COMPILE_LANGUAGE:C>:-D_XOPEN_SOURCE=600>")
endif()

#configure the scipbuildflags.c source file for the build tree
configure_file(${PROJECT_SOURCE_DIR}/src/scipbuildflags.c.in
  "${PROJECT_BINARY_DIR}/scipbuildflag.c" @ONLY)

set(scipsources
    ${PROJECT_BINARY_DIR}/scipbuildflag.c
    blockmemshell/memory.c
    scip/message.c
    scip/bitencode.c
    scip/bandit.c
    scip/bandit_epsgreedy.c
    scip/bandit_exp3.c
    scip/bandit_exp3ix.c
    scip/bandit_ucb.c
    scip/branch_allfullstrong.c
    scip/branch_cloud.c
    scip/branch_distribution.c
    scip/branch_fullstrong.c
    scip/branch_gomory.c
    scip/branch_inference.c
    scip/branch_leastinf.c
    scip/branch_lookahead.c
    scip/branch_mostinf.c
    scip/branch_multaggr.c
    scip/branch_nodereopt.c
    scip/branch_pscost.c
    scip/branch_random.c
    scip/branch_relpscost.c
    scip/branch_vanillafullstrong.c
    scip/certificate.cpp
    scip/compr_largestrepr.c
    scip/compr_weakcompr.c
    scip/concsolver_scip.c
    scip/cons_and.c
    scip/cons_benders.c
    scip/cons_benderslp.c
    scip/cons_bounddisjunction.c
    scip/cons_cardinality.c
    scip/cons_components.c
    scip/cons_conjunction.c
    scip/cons_countsols.c
    scip/cons_cumulative.c
    scip/cons_disjunction.c
    scip/cons_exactlinear.c
    scip/cons_exactsol.c
    scip/cons_fixedvar.c
    scip/cons_indicator.c
    scip/cons_integral.c
    scip/cons_knapsack.c
    scip/cons_linear.c
    scip/cons_linking.c
    scip/cons_logicor.c
    scip/cons_nonlinear.c
    scip/cons_or.c
    scip/cons_orbisack.c
    scip/cons_orbitope.c
    scip/cons_orbitope_full.c
    scip/cons_orbitope_pp.c
    scip/cons_pseudoboolean.c
    scip/cons_setppc.c
    scip/cons_sos1.c
    scip/cons_sos2.c
    scip/cons_superindicator.c
    scip/cons_symresack.c
    scip/cons_varbound.c
    scip/cons_xor.c
    scip/cutsel_ensemble.c
    scip/cutsel_hybrid.c
    scip/cutsel_dynamic.c
    scip/dcmp.c
    scip/dialog_default.c
    scip/event_globalbnd.c
    scip/event_estim.c
    scip/event_shadowtree.c
    scip/event_softtimelimit.c
    scip/event_solvingphase.c
    scip/expr_abs.c
    scip/expr_entropy.c
    scip/expr_erf.c
    scip/expr_exp.c
    scip/expr_log.c
    scip/expr_pow.c
    scip/expr_product.c
    scip/expr_sum.c
    scip/expr_trig.c
    scip/expr_value.c
    scip/expr_var.c
    scip/expr_varidx.c
    ${exprinterpret}
    scip/disp_default.c
    scip/heur_actconsdiving.c
    scip/heur_adaptivediving.c
    scip/heur_bound.c
    scip/heur_clique.c
    scip/heur_coefdiving.c
    scip/heur_completesol.c
    scip/heur_conflictdiving.c
    scip/heur_crossover.c
    scip/heur_dins.c
    scip/heur_distributiondiving.c
    scip/heur_dks.c
    scip/heur_dps.c
    scip/heur_dualval.c
    scip/heur_farkasdiving.c
    scip/heur_feaspump.c
    scip/heur_fixandinfer.c
    scip/heur_fracdiving.c
    scip/heur_gins.c
    scip/heur_guideddiving.c
    scip/heur_indicator.c
    scip/heur_indicatordiving.c
    scip/heur_intdiving.c
    scip/heur_intshifting.c
    scip/heur_linesearchdiving.c
    scip/heur_localbranching.c
    scip/heur_lpface.c
    scip/heur_locks.c
    scip/heur_alns.c
    scip/heur_mutation.c
    scip/heur_multistart.c
    scip/heur_mpec.c
    scip/heur_nlpdiving.c
    scip/heur_objpscostdiving.c
    scip/heur_octane.c
    scip/heur_ofins.c
    scip/heur_oneopt.c
    scip/heur_padm.c
    scip/heur_proximity.c
    scip/heur_pscostdiving.c
    scip/heur_reoptsols.c
    scip/heur_repair.c
    scip/heur_randrounding.c
    scip/heur_rens.c
    scip/heur_rins.c
    scip/heur_rootsoldiving.c
    scip/heur_rounding.c
    scip/heur_scheduler.c
    scip/heur_shiftandpropagate.c
    scip/heur_shifting.c
    scip/heur_simplerounding.c
    scip/heur_subnlp.c
    scip/heur_sync.c
    scip/heur_trivial.c
    scip/heur_trivialnegation.c
    scip/heur_trustregion.c
    scip/heur_trysol.c
    scip/heur_twoopt.c
    scip/heur_undercover.c
    scip/heur_vbounds.c
    scip/heur_veclendiving.c
    scip/heur_zeroobj.c
    scip/heur_zirounding.c
    scip/hypergraph.c
    scip/iisfinder_greedy.c
    scip/message_default.c
    scip/network.c
    scip/nlhdlr_bilinear.c
    scip/nlhdlr_convex.c
    scip/nlhdlr_default.c
    scip/nlhdlr_perspective.c
    scip/nlhdlr_quadratic.c
    scip/nlhdlr_quotient.c
    scip/nlhdlr_signomial.c
    scip/nlhdlr_soc.c
    scip/nlpi_all.c
    ${nlpi}
    scip/nodesel_bfs.c
    scip/nodesel_breadthfirst.c
    scip/nodesel_dfs.c
    scip/nodesel_estimate.c
    scip/nodesel_hybridestim.c
    scip/nodesel_restartdfs.c
    scip/nodesel_uct.c
    scip/presol_milp.cpp
    scip/presol_boundshift.c
    scip/presol_convertinttobin.c
    scip/presol_domcol.c
    scip/presol_dualagg.c
    scip/presol_dualcomp.c
    scip/presol_dualinfer.c
    scip/presol_gateextraction.c
    scip/presol_implics.c
    scip/presol_implint.c
    scip/presol_inttobinary.c
    scip/presol_qpkktref.c
    scip/presol_redvub.c
    scip/presol_sparsify.c
    scip/presol_dualsparsify.c
    scip/presol_stuffing.c
    scip/presol_trivial.c
    scip/presol_tworowbnd.c
    scip/prop_dualfix.c
    scip/prop_genvbounds.c
    scip/prop_nlobbt.c
    scip/prop_obbt.c
    scip/prop_probing.c
    scip/prop_pseudoobj.c
    scip/prop_redcost.c
    scip/prop_rootredcost.c
    scip/prop_symmetry.c
    scip/prop_vbounds.c
    scip/prop_symmetry.c
    scip/prop_sync.c
    scip/reader_bnd.c
    scip/reader_ccg.c
    scip/reader_cip.c
    scip/reader_cnf.c
    scip/reader_cor.c
    scip/reader_dec.c
    scip/reader_diff.c
    scip/reader_fix.c
    scip/reader_fzn.c
    scip/reader_gms.c
    scip/reader_lp.c
    scip/reader_mps.c
    scip/reader_mst.c
    scip/reader_opb.c
    scip/reader_osil.c
    scip/reader_pip.c
    scip/reader_pbm.c
    scip/reader_ppm.c
    scip/reader_rlp.c
    scip/reader_sol.c
    scip/reader_sto.c
    scip/reader_smps.c
    scip/reader_tim.c
    scip/reader_wbo.c
    scip/reader_zpl.c
    scip/sepa_cgmip.c
    scip/sepa_clique.c
    scip/sepa_closecuts.c
    scip/sepa_aggregation.c
    scip/sepa_convexproj.c
    scip/sepa_disjunctive.c
    scip/sepa_eccuts.c
    scip/sepa_flower.c
    scip/sepa_gauge.c
    scip/sepa_gomory.c
    scip/sepa_impliedbounds.c
    scip/sepa_interminor.c
    scip/sepa_intobj.c
    scip/sepa_lagromory.c
    scip/sepa_mcf.c
    scip/sepa_minor.c
    scip/sepa_mixing.c
    scip/sepa_oddcycle.c
    scip/sepa_rapidlearning.c
    scip/sepa_rlt.c
    scip/sepa_zerohalf.c
    scip/treemodel.c
    scip/benders_default.c
    scip/benderscut_feas.c
    scip/benderscut_feasalt.c
    scip/benderscut_int.c
    scip/benderscut_nogood.c
    scip/benderscut_opt.c
    scip/table_default.c
    scip/benders.c
    scip/benderscut.c
    scip/bendersdefcuts.c
    scip/relax_benders.c
    scip/boundstore.c
    scip/branch.c
    scip/clock.c
    scip/concsolver.c
    scip/concurrent.c
    scip/conflict_general.c
    scip/conflict_graphanalysis.c
    scip/conflict_dualproofanalysis.c
    scip/conflict_resolution.c
    scip/conflictstore.c
    scip/cons.c
    scip/cutpool.c
    scip/cuts.c
    scip/cutsel.c
    scip/debug.c
    scip/dialog.c
    scip/disp.c
    scip/event.c
    scip/expr.c
    scip/exprcurv.c
    scip/expriter.c
    scip/fileio.c
    scip/heur.c
    scip/heuristics.c
    scip/compr.c
    scip/history.c
    scip/iisfinder.c
    scip/implics.c
    scip/interrupt.c
    scip/intervalarith.c
    scip/lapack_calls.c
    scip/lp.c
    scip/lpexact.c
    scip/lpexact_bounding.c
    scip/matrix.c
    scip/mem.c
    scip/misc.c
    scip/misc_linear.c
    scip/misc_rowprep.c
    scip/nlhdlr.c
    scip/nlp.c
    scip/nlpi.c
    scip/nlpioracle.c
    scip/nodesel.c
    scip/paramset.c
    scip/presol.c
    scip/presolve.c
    scip/pricestore.c
    scip/pricer.c
    scip/primal.c
    scip/prob.c
    scip/prop.c
    scip/rational.cpp
    scip/reader.c
    scip/relax.c
    scip/reopt.c
    scip/retcode.c
    scip/scip_bandit.c
    scip/scip_benders.c
    scip/scip_branch.c
    scip/scip_certificate.c
    scip/scip_compr.c
    scip/scip_concurrent.c
    scip/scip_conflict.c
    scip/scip_cons.c
    scip/scip_copy.c
    scip/scip_cut.c
    scip/scip_cutsel.c
    scip/scip_datastructures.c
    scip/scip_datatree.c
    scip/scip_debug.c
    scip/scip_dcmp.c
    scip/scip_dialog.c
    scip/scip_disp.c
    scip/scip_event.c
    scip/scip_exact.c
    scip/scip_expr.c
    scip/scip_general.c
    scip/scip_heur.c
    scip/scip_iisfinder.c
    scip/scip_lp.c
    scip/scip_lpexact.c
    scip/scip_mem.c
    scip/scip_message.c
    scip/scip_nlp.c
    scip/scip_nlpi.c
    scip/scip_nodesel.c
    scip/scip_numerics.c
    scip/scip_param.c
    scip/scip_presol.c
    scip/scip_pricer.c
    scip/scip_prob.c
    scip/scip_probing.c
    scip/scip_prop.c
    scip/scip_randnumgen.c
    scip/scip_reader.c
    scip/scip_relax.c
    scip/scip_reopt.c
    scip/scip_sepa.c
    scip/scip_sol.c
    scip/scip_solve.c
    scip/scip_solvingstats.c
    scip/scip_table.c
    scip/scip_timing.c
    scip/scip_tree.c
    scip/scip_validation.c
    scip/scip_var.c
    scip/datatree.c
    scip/scipdefplugins.c
    scip/scipcoreplugins.c
    scip/scipgithash.c
    scip/scipshell.c
    scip/sepa.c
    scip/sepastore.c
    scip/sepastoreexact.c
    scip/set.c
    scip/sol.c
    scip/solve.c
    scip/stat.c
    scip/symmetry.c
    scip/symmetry_graph.c
    scip/symmetry_orbitopal.c
    scip/symmetry_orbital.c
    scip/symmetry_lexred.c
    scip/syncstore.c
    scip/table.c
    scip/tree.c
    scip/var.c
    scip/visual.c
    scip/rbtree.c
    tclique/tclique_branch.c
    tclique/tclique_coloring.c
    tclique/tclique_graph.c
    dijkstra/dijkstra.c
    xml/xmlparse.c
    ${amplsrc}
)

set(objscipsources
    objscip/objbenders.cpp
    objscip/objbenderscut.cpp
    objscip/objbranchrule.cpp
    objscip/objconshdlr.cpp
    objscip/objcutsel.cpp
    objscip/objdialog.cpp
    objscip/objdisp.cpp
    objscip/objeventhdlr.cpp
    objscip/objexprhdlr.cpp
    objscip/objheur.cpp
    objscip/objiisfinder.cpp
    objscip/objmessagehdlr.cpp
    objscip/objnodesel.cpp
    objscip/objpresol.cpp
    objscip/objpricer.cpp
    objscip/objprobdata.cpp
    objscip/objprop.cpp
    objscip/objreader.cpp
    objscip/objrelax.cpp
    objscip/objsepa.cpp
    objscip/objtable.cpp
    objscip/objvardata.cpp
)

set(lpisources
   ${lpi}
   )

set(symsources
   ${sym}
   )

set(lpiexactsources
   ${lpiexact}
   )

if(SCIP_WITH_EXACTSOLVE)
set(rectlusources
   rectlu/rectlu_factor.c
   rectlu/rectlu_num.c
   )

set(rectluheaders
    rectlu/rectlu.h
    rectlu/rectlu_num.h
    rectlu/rectlu_factor.h)
endif()

set(blockmemshellheader
    blockmemshell/memory.h
)

set(lpiheaders
    lpi/lpi.h
    lpi/type_lpi.h
)

set(lpiexactheaders
    lpiexact/lpiexact.h
    lpiexact/type_lpiexact.h
)

set(dijkstraheaders
    dijkstra/dijkstra.h
)

set(objscipheaders
    objscip/objbenders.h
    objscip/objbenderscut.h
    objscip/objbranchrule.h
    objscip/objcloneable.h
    objscip/objconshdlr.h
    objscip/objcutsel.h
    objscip/objdialog.h
    objscip/objdisp.h
    objscip/objeventhdlr.h
    objscip/objexprhdlr.h
    objscip/objheur.h
    objscip/objiisfinder.h
    objscip/objmessagehdlr.h
    objscip/objnodesel.h
    objscip/objpresol.h
    objscip/objpricer.h
    objscip/objprobcloneable.h
    objscip/objprobdata.h
    objscip/objprop.h
    objscip/objreader.h
    objscip/objrelax.h
    objscip/objscipdefplugins.h
    objscip/objscip.h
    objscip/objsepa.h
    objscip/objtable.h
    objscip/objvardata.h
    objscip/type_objcloneable.h
    objscip/type_objprobcloneable.h
)

set(scipheaders
    scip/bandit.h
    scip/bandit_epsgreedy.h
    scip/bandit_exp3.h
