=== debian/changelog ===
scip (10.0.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Source-only upload for transition to testing.
  * debian/control
    - Add libzimpl-dev and zimpl to Build-Depends.
  * debian/copyright
    - Update upstream copyright years.
  * debian/libscip10.0.symbols
    - Remove file; too difficult to maintain.
  * debian/rules
    - Build with zimpl support.
  * debian/tests/CTestTestfile.cmake
    - Add zimpl tests.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 25 Feb 2026 22:45:19 -0500
