=== debian/control ===
Source: scip
Section: math
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: cmake,
               coinor-libipopt-dev,
               debhelper-compat (= 13),
               gfortran,
               help2man,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libgmp-dev,
               libmpfr-dev,
               libnauty-dev,
               libpapilo-dev,
               libreadline-dev,
               libsoplex-dev,
               libz-dev,
               libzimpl-dev,
               pkgconf,
               zimpl
Build-Depends-Indep: doxygen, python3-minimal
Standards-Version: 4.7.3
Homepage: https://scipopt.org/
Vcs-Browser: https://salsa.debian.org/math-team/scip
Vcs-Git: https://salsa.debian.org/math-team/scip.git

Package: scip
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: scip-doc
Description: Solving Constraint Integer Programs (command line tool)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the SCIP command line tool.

Package: libscip10.0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Solving Constraint Integer Programs (shared libraries)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the SCIP shared libraries.

Package: libscip-dev
Section: libdevel
Architecture: any
Depends: libscip10.0 (=${binary:Version}), ${misc:Depends}
Recommends: scip-doc
Description: Solving Constraint Integer Programs (development files)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the development files for the SCIP library.

Package: scip-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Solving Constraint Integer Programs (documentation)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the documentation.
