=== debian/tests/control ===
Test-Command: cp debian/tests/CTestTestfile.cmake $AUTOPKGTEST_TMP &&
	      sed -i "s|@BUILDDIR@|$(pwd)|g" $AUTOPKGTEST_TMP/CTestTestfile.cmake &&
	      ctest --test-dir $AUTOPKGTEST_TMP
Depends: scip, cmake
