=== debian/watch ===
version=4
# we assume that 3-digit tags need dots, e.g., v924 -> 9.2.4
opts=uversionmangle=s/^([0-9])([0-9])([0-9])$/$1.$2.$3/,\
repacksuffix=+ds,dversionmangle=auto,repack \
https://github.com/scipopt/scip/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
